%if 0%{?rhel} >= 7 || 0%{?fedora}
%bcond_without systemd  # enabled
%else
%bcond_with systemd     # disabled
%endif

Summary: An Eudora and NUPOP change password server.
Name: poppassd
Version: 1.8.9
Release: 3%{?dist}
URL: http://bolanda.net/f/poppassd.html
Source0: http://bolanda.net/f/%{name}-ceti-%{version}.tar.gz
Source1: poppassd.pam
Source2: poppassd.xinetd
Source404: poppassd.sysconfig
Patch0: poppassd-1.8.5.redhat.patch
# questa patch non ricordo + dove l'ho presa, e non la trovo. Somiglia parecchio a una somma delle seguenti (ma non e' un mero accumulo di) per cui uso quelle che almeno si sa da dove vengono
Patch100: poppassd-1.8.6.patch
# Prese da http://bugs.gentoo.org/show_bug.cgi?id=145839
Patch201: poppassd.c-1.patch
Patch202: poppassd.c-2.patch
Patch203: poppassd.c-3.patch
Patch204: poppassd.c-4.patch
Patch205: poppassd.c-5.patch
# Mia x C6 che richiede la pass la seconda volte con prompt "retype new password"
Patch300: poppassd.c-retypeNewPassword.patch
# Idem x i prompt di pam_passwdqc; aggiunge anche la richiesta standard di C6 x la password attuale ((current) UNIX password)
Patch301: poppassd_pam_passwdqc.patch
# Fai build e install da non root, x fare gli rpm
Patch400: poppassd-1.8.5-install_noroot.patch
# Build on ContOS8: cmake is 3.11; strcasestr needs _GNU_SOURCE; install directive needs DESTINATION
Patch401: poppassd-1.8.9.C8.1.patch
Patch402: poppassd-1.8.9.C8.systemd.patch
Patch403: poppassd-1.8.9.C8.optminuid.2.patch
Patch404: poppassd-1.8.9.sysconfigenv.patch
License: Distributable
Provides: poppassd
Requires: pam net-tools setup rsyslog
%if %{with systemd}
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units
BuildRequires:    systemd
%else
Requires: xinetd
%endif
Group: Networking/Remote access

%description
This program is based on original Qualcomm password changer daemon 
dedicated for, well, changing system passwords over network. 
The most common usage is to change user's passwords using a web form. 
The rationale behind using poppassd for that purpose is to separate 
web frontend (low privileges) from the system backend (root privileges 
necessary to change password). This program was written when I saw some 
hacks involving use of SUID CGIs etc.

%prep
%setup -n %{name}-ceti-%{version}
#%patch0 -p1
#%patch100 -p1
#%patch201 -p0
#%patch202 -p0
#%patch203 -p0
#%patch204 -p0
#%patch205 -p0
#%patch300 -p0
#%patch301 -p0
#%patch400 -p1
%patch401 -p0
%patch402 -p1
%patch403 -p0
%patch404 -p0
%if 0%{?rhel} >= 8 || 0%{?fedora} >= 27
perl -pi -e 's/define\s+POP_MIN_UID\s+\K100\s*$/1000/' poppassd.c
%else
perl -pi -e 's/define\s+POP_MIN_UID\s+\K100\s*$/500/' poppassd.c
%endif

%build
%cmake .
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin \
         $RPM_BUILD_ROOT%{_sysconfdir}/pam.d \
%if %{with systemd}
         $RPM_BUILD_ROOT%{_unitdir} \
         $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
%else
         $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d
%endif
make INSTALL_PREFIX=$RPM_BUILD_ROOT DESTDIR=$RPM_BUILD_ROOT install
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/poppassd
install %{SOURCE404} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/poppassd
%if ! %{with systemd}
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/poppassd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{with systemd}
%systemd_post poppassd.socket
%endif

%preun
%if %{with systemd}
%systemd_preun poppassd.socket
%endif

%postun
%if %{with systemd}
%systemd_postun_with_restart poppassd.socket
%endif

%files
%defattr(-,root,root)
%doc README.md LICENSE
%attr(0700,root,root) %{_prefix}/sbin/poppassd
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/pam.d/poppassd
%if %{with systemd}
%{_unitdir}/poppassd@.service
%{_unitdir}/poppassd.socket
%config(noreplace) %{_sysconfdir}/sysconfig/poppassd
%else
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/poppassd
%endif

%changelog
* Wed Jun 01 2005 Oliver Schulze L. <oliver@samera.com.py> 1.8.5-co4
- renamed spec file to poppassd-ceti-185.spec
- tested in CentOS 4, rebuild with:
  rpmbuild -ba -D "release co4" poppassd-ceti-185.spec

* Wed Mar 30 2005 Oliver Schulze L. <oliver@samera.com.py> 1.8.5-fc3
- updated to 1.8.5
- Build on Fedora Core 3
- suported to build in any redhat/fedora system, just build the .src.rpm
  like this(for redhat 7.3):
  rpmbuild -ba -D "release rh73" poppassd-ceti-185.spec

* Thu Jul 03 2003 Oliver Schulze L. <oliver@samera.com.py> 1.8.3-1rh9
- updated to 1.8.2
- Build on RedHat Linux 9

* Wed Oct 02 2002 Oliver Schulze L. <oliver@samera.com.py> 1.8.2-1rh73
- updated to 1.8.2
- build on RedHat Linux 7.3

* Wed Oct 02 2002 Oliver Schulze L. <oliver@samera.com.py> 1.8.1-1rh73
- build on RedHat Linux 7.3

* Mon Apr 08 2002 Oliver Schulze L. <oliver@samera.com.py> 1.8.1-1rh7
- using one patch instead of many small ones
- using the save config for pam as /etc/pam.d/passwd in RH7x
- Updated to 1.8.1

* Fri Mar 08 2002 Oliver Schulze L. <oliver@samera.com.py> 1.8-3
- changed POP_MIN_UID to 500
- build on RedHat 7.1

* Thu Sep 06 2001 Philippe Libat <philippe@mandrakesoft.com> 1.8-2mdk
- fix require

* Mon Sep 03 2001 Giuseppe Ghibo' <ghibo@mandrakesoft.com> 1.8-1mdk
- initial release.
